
#include "gui.h"

static int (*gui_select_callback)(int)=NULL;

/* File menu  -------- */
static MENU file_menu[] = {
  {     "&Open", NULL, NULL, 0, NULL },
  {          "", NULL, NULL, 0, NULL },
  { "&Snapshot", NULL, NULL, 0, NULL },
  {          "", NULL, NULL, 0, NULL },
  {     "E&xit", NULL, NULL, 0, NULL },
  {        NULL, NULL, NULL, 0, NULL }
};

/* Gameboy menu ------ */
static int select_0();
static int select_1();
static int select_2();
static int select_3();
static int select_4();
static int select_5();
static int select_6();
static int select_7();
static int select_8();
static int select_9();

static MENU select_menu[] = {
  { "Slot #&0", select_0, NULL, D_SELECTED, NULL },
  { "Slot #&1", select_1, NULL, 0, NULL },
  { "Slot #&2", select_2, NULL, 0, NULL },
  { "Slot #&3", select_3, NULL, 0, NULL },
  { "Slot #&4", select_4, NULL, 0, NULL },
  { "Slot #&5", select_5, NULL, 0, NULL },
  { "Slot #&6", select_6, NULL, 0, NULL },
  { "Slot #&7", select_7, NULL, 0, NULL },
  { "Slot #&8", select_8, NULL, 0, NULL },
  { "Slot #&9", select_9, NULL, 0, NULL },
  { NULL, NULL, NULL, 0, NULL }
};

static MENU state_menu[] = {
  {  "Se&lect", NULL, select_menu, 0, NULL },
  {         "", NULL,        NULL, 0, NULL },
  {    "&Save", NULL,        NULL, 0, NULL },
  { "&Restore", NULL,        NULL, 0, NULL },
  {       NULL, NULL,        NULL, 0, NULL },
  
};

static MENU gameboy_menu[] = {
  {     "&Reset", NULL,       NULL, 0, NULL },
  {           "", NULL,       NULL, 0, NULL },
  { "R&egisters", NULL,       NULL, 0, NULL },
  {           "", NULL,       NULL, 0, NULL },
  {     "&State", NULL, state_menu, 0, NULL },
  {         NULL, NULL,       NULL, 0, NULL }
};

/* Main menu */
static MENU main_menu[] = {
  {  "G&ooBer", NULL,    file_menu, 0, NULL },
  { "&Gameboy", NULL, gameboy_menu, 0, NULL },
  {       NULL, NULL,         NULL, 0, NULL }
};

void gui_show_menu()
{
  show_mouse(screen);
  do_menu(main_menu, 5, 5);
  show_mouse(NULL);
}

/* File menu callbacks */
void gui_set_file_callback(int index, int (*p)())
{
  file_menu[index].proc = p;
}

/* Gameboy menu callbacks */
void gui_set_gb_callback(int index, int (*callback)())
{
  gameboy_menu[index].proc = callback;
}

/* State menu callbacks */
void gui_set_state_callback(int index, int (*callback)())
{
  state_menu[index].proc = callback;
}

/* Select menu callback */
void gui_set_select_callback(int (*callback)(int))
{
  gui_select_callback = callback; 
}

/* Set selected state */
void gui_set_selected_state(int state)
{
  int i;

  if (state <= 9) {
    for (i=0; i<9; i++) {
      if(select_menu[i].flags == D_SELECTED) {
	select_menu[i].flags=0;
	break;
      }
    }

    select_menu[state].flags=D_SELECTED;
  }
}

void gui_enable_menu(int index, int state)
{
  if (state) 
    main_menu[index].flags = 0;
  else
    main_menu[index].flags = D_DISABLED;
}

void gui_gb_selected(int index, int state)
{
  if (state) {
    gameboy_menu[index].flags = D_SELECTED;
  }
  else {
    gameboy_menu[index].flags = 0;
  }
}

int window_proc(int msg, DIALOG *c, int ch)
{
  if (msg == MSG_DRAW) {
    rectfill(screen, c->x, c->y, c->w, c->h, c->bg);
    rect(screen, c->x, c->y, c->w, c->h, c->fg);
  }
  return D_O_K;
}

static int select_0()
{
  if (gui_select_callback) 
    return gui_select_callback(0);
  else
    return 1;
}
static int select_1()
{
  if (gui_select_callback) 
    return gui_select_callback(1);
  else
    return 1;
}
static int select_2()
{
  if (gui_select_callback) 
    return gui_select_callback(2);
  else
    return 1;
}
static int select_3()
{
  if (gui_select_callback) 
    return gui_select_callback(3);
  else
    return 1;
}
static int select_4()
{
  if (gui_select_callback) 
    return gui_select_callback(4);
  else
    return 1;
}
static int select_5()
{
  if (gui_select_callback) 
    return gui_select_callback(6);
  else
    return 1;
}
static int select_6()
{
  if (gui_select_callback) 
    return gui_select_callback(6);
  else
    return 1;
}
static int select_7()
{
  if (gui_select_callback) 
    return gui_select_callback(7);
  else
    return 1;
}
static int select_8()
{
  if (gui_select_callback) 
    return gui_select_callback(8);
  else
    return 1;
}
static int select_9()
{
  if (gui_select_callback) 
    return gui_select_callback(9);
  else
    return 1;
}



