
#include <stdio.h>
#include "mbc/romonly.h"

/* Memory banks */
static unsigned char *rom0;
static unsigned char *rom1;
static unsigned char exram[0x2000]={0};

/* reset function */
void romonly_reset()
{
  /* Does nothing */
}

int romonly_load(cart_info *this)
{

  mbc_reset = romonly_reset;

  rom0 = &(this->rombanks[0]);
  rom1 = &(this->rombanks[0x4000]);

  set_rom0_source(rom0);
  set_rom1_source(rom1);
  set_exram_source(exram);

  set_rom0_handlers(romonly_rom0_read, romonly_rom0_write);
  set_rom1_handlers(romonly_rom1_read, romonly_rom1_write);
  set_exram_handlers(romonly_exram_read, romonly_exram_write);
}

/* Memory access handlers */
unsigned char romonly_rom0_read(unsigned short addr)
{
  return rom0[addr];
}

void romonly_rom0_write(unsigned short addr, unsigned char value)
{
  /* WRITE ONLY */
}

unsigned char romonly_rom1_read(unsigned short addr)
{
  return rom1[addr];
}

void romonly_rom1_write(unsigned short addr, unsigned char value)
{
  /* WRITE ONLY */
}

unsigned char romonly_exram_read(unsigned short addr)
{
  return 0xFF;
}

void romonly_exram_write(unsigned short addr, unsigned char value)
{
  /* Does nothing */
}

